osgManipulator::Projector Class Referenceabstract

`#include <Projector>`

Inheritance diagram for osgManipulator::Projector:

## Public Member Functions

| Projector ()
virtual bool | project (const PointerInfo &pi, osg::Vec3d &projectedPoint) const =0
void | setLocalToWorld (const osg::Matrix &localToWorld)
const osg::Matrix & | getLocalToWorld () const
const osg::Matrix & | getWorldToLocal () const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
virtual void | setThreadSafeRefUnref (bool)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const

## Protected Member Functions

virtual | ~Projector ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Protected Attributes

osg::Matrix | _localToWorld
osg::Matrix | _worldToLocal
bool | _worldToLocalDirty
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Additional Inherited Members

Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Detailed Description

Base class for Projectors. Projectors maps 2D cursor motions to 3D motions.

## Constructor & Destructor Documentation

## Projector()

osgManipulator::Projector::Projector | ( |  | ) |

## ~Projector()

virtual osgManipulator::Projector::~Projector | ( |  | ) |

protected virtual

## Member Function Documentation

## getLocalToWorld()

const osg::Matrix & osgManipulator::Projector::getLocalToWorld | ( |  | ) | const

inline

Gets the matrix for transforming the projector's local coordinate system to the world/object coordinate system.

References _localToWorld.

## getWorldToLocal()

const osg::Matrix & osgManipulator::Projector::getWorldToLocal | ( |  | ) | const

inline

Gets the matrix for transforming the world/object coordinate system to the command's local coordinate system.

References _localToWorld, _worldToLocal, and _worldToLocalDirty.

## project()

virtual bool osgManipulator::Projector::project | ( | const PointerInfo & | pi,
|  | osg::Vec3d & | projectedPoint ) const

pure virtual

Calculates the object/world coordinates (projectedPoint) of a window coordinate (pointToProject) when projected onto some shape or geometry (implemented in derived classes). SceneView in used for i projecting window coordinates into object coordinates and vice versa. Returns true on successful projection.

Implemented in osgManipulator::CylinderPlaneProjector, osgManipulator::CylinderProjector, osgManipulator::LineProjector, osgManipulator::PlaneProjector, osgManipulator::SpherePlaneProjector, and osgManipulator::SphereProjector.

## setLocalToWorld()

void osgManipulator::Projector::setLocalToWorld | ( | const osg::Matrix & | localToWorld | ) |

inline

Sets the matrix for transforming the projector's local coordinate system to the world/object coordinate system.

References _localToWorld, and _worldToLocalDirty.

## Member Data Documentation

## _localToWorld

osg::Matrix osgManipulator::Projector::_localToWorld

protected

Referenced by getLocalToWorld(), getWorldToLocal(), and setLocalToWorld().

## _worldToLocal

osg::Matrix osgManipulator::Projector::_worldToLocal

mutable protected

Referenced by getWorldToLocal().

## _worldToLocalDirty

bool osgManipulator::Projector::_worldToLocalDirty

mutable protected

Referenced by getWorldToLocal(), and setLocalToWorld().

The documentation for this class was generated from the following file:

- Projector